﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Sinuser extends Sprite
	{
		private var bmp:BitmapData;
		private var angle:uint = 0;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(1.01,1.01,2);
		private var colors:Array = [0x6666FF,0x0000ff];
		public function Sinuser()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmp = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			addChild(new Bitmap(bmp));
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function buildCycle(target:Sprite,angle:uint):Sprite
		{	
			var point:Sprite = new Sprite();
			point.graphics.lineStyle(1,colors[angle%2],1);
			point.graphics.moveTo(0,0);
			point.graphics.lineTo(0,20);
			target.addChild(point);
			point.x = Math.cos(angle*Math.PI/180)*10;
			point.y = Math.cos(angle*Math.PI/180)*10;
			return point;
		}
		private function enterHandler(e:Event):void
		{
			var basis:Sprite = new Sprite();
			basis.x = stage.stageWidth/2;
			basis.y = stage.stageHeight/2;
			basis.alpha = Math.random();
			support.addChild(basis);
			for(var i:uint=0;i<100;i++){
				basis = buildCycle(basis,angle*i);
			}
			var m:Matrix = new Matrix();
			m.rotate(angle/20);
			m.translate(stage.stageWidth*2,stage.stageHeight*2);
			m.scale(0.25,0.25);
			if(angle%10 == 0){
				bmp.applyFilter(bmp,bmp.rect,new Point(0,0),filterObj);
			}
			bmp.draw(support,m);
			support.removeChildAt(0);
			angle++;
		}
	}
}